--[[

    File: glutil.lua 

    Copyright (C) 2000-2009 Christopher Moore (christopher.e.moore@gmail.com)
          
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

--]]


printGLLogs = true
-- i might just build this into every gl call.  or make it a flag at least
function glreport(name)
	if printGLLogs then
		local e = gl.glGetError()
		if e ~= 0 then
			local str = name
			if str then
				str = str .. ': '..e 
			else
				str = e
			end
			print(str)
			print(debug.traceback())
		end
	end
end


-- TODO - move to tex.lua
function getTexData(tex)
	gl.glBindTexture(gl.GL_TEXTURE_2D, tex)
	-- getting an error right here
	local p = gl.glGetTexImage(gl.GL_TEXTURE_2D, 0)	-- i forget what that zero is all about
	local w = gl.glGetTexLevelParameter(gl.GL_TEXTURE_2D, 0, gl.GL_TEXTURE_WIDTH)
	local h = gl.glGetTexLevelParameter(gl.GL_TEXTURE_2D, 0, gl.GL_TEXTURE_HEIGHT)	
	local ptype = type(p)
	assert(ptype == 'table', 'p got a bad type '..ptype)
	assert(#p == w*h*4, 'i expected #p to be '..(w*h*4)..' but it turns out to be '..#p)
	gl.glBindTexture(gl.GL_TEXTURE_2D, 0)
	return p
end

function drawOverlay(callback)
	-- save and reset matrix state
	gl.glMatrixMode(gl.GL_PROJECTION)
	gl.glPushMatrix()
	gl.glLoadIdentity()
	gl.glOrtho(0,1,0,1,-1,1)
	gl.glMatrixMode(gl.GL_MODELVIEW)
	gl.glPushMatrix()
	gl.glLoadIdentity()
	
	-- run the goods
	callback()

	-- restore matrix state
	gl.glMatrixMode(gl.GL_PROJECTION)
	gl.glPopMatrix()
	gl.glMatrixMode(gl.GL_MODELVIEW)
	gl.glPopMatrix()
end

-- TODO - make this a member function of FBO
-- consider making it FBO:draw and renaming the above
function drawScreenQuad()
	glreport('begin drawScreenQuad')
	gl.glBegin(gl.GL_QUADS)
	gl.glTexCoord(0,0)	gl.glVertex(0,0)
	gl.glTexCoord(1,0)	gl.glVertex(1,0)
	gl.glTexCoord(1,1)	gl.glVertex(1,1)
	gl.glTexCoord(0,1)	gl.glVertex(0,1)
	gl.glEnd()
	glreport('end drawScreenQuad')
end


